<html>

<head>
    <title>Zone de travail (canvas)</title>
    <script src="../../CodeSource/fabric.js-363/dist/fabric.js"></script>
    <script src="jquery-3.4.1.js"></script>
    <script src="jquery-ui.js"></script>
    <script src="../node_modules/modernizr/src/Modernizr.js"></script>

    <style>
        canvas {
            border: 1px solid black;
        }
    </style>
</head>

<body>
    <h1> Glissez et déposer un élément de chantiers </h1>

    <div class="canvas-container">
        <canvas></canvas>
    </div>

    <div class="elementChantiers">
        <img draggable="true" src="../../CodeSource/image/librairie/DYN-cam15.png">
        <img draggable="true" class="librarySectionLine">
    </div>

    <script type="text/javascript">
        // Script englobant toutes les fonctions de Drag & Drop
        function initCanvas() {
            $('.canvas-container').each(function(index) {
                // Sélectiond du canvas
                var canvasContainer = $(this)[0];
                var canvasObject = $("canvas", this)[0];
                var url = $(this).data('floorplan');

                var canvas = window._canvas = new fabric.Canvas(canvasObject);

                canvas.setHeight(200);
                canvas.setWidth(500);

                canvas.setBackgroundImage(url, canvas.renderAll.bind(canvas));

                //Echelle du canvas, utilisée pour les cotations
                var scale;
                $("#scale").on('input', function() {
                    try {
                        scale = $("#scale").val();
                        scale = Number(scale);
                        if (scale == null || scale < 0 || (isNaN(scale))) {
                            scale = Number(1);
                        }
                    } catch (error) {
                        scale = Number(1);
                    }
                    if (scale != 1) {
                        $("#scale").val(scale);
                    }
                });

                var positionX, positionY;

                // Décomposition du drag and drop en 5 fonctions DRAG et 1 fonction DROP
                // Fonction DRAG START
                function handleDragStart(e) {
                    [].forEach.call(images, function(img) {
                        img.classList.remove('img_dragging');
                    });
                    this.classList.add('img_dragging');

                    var position = $(this).offset();
                    positionX = e.clientX - position.left;
                    positionY = e.clientY - position.top;
                }

                // Fonction DRAG OVER
                function handleDragOver(e) {
                    if (e.preventDefault) {
                        e.preventDefault();
                    }
                    e.dataTransfer.dropEffect = 'copy';
                    return false;
                }

                // Fonction DRAG ENTER
                function handleDragEnter(e) {
                    this.classList.add('over');
                }

                //Fonction DRAG LEAVE
                function handleDragLeave(e) {
                    this.classList.remove('over');
                }

                // Fonction DROP : insertion de l'image qui a été déposée sur le cadastre
                function handleDrop(e) {
                    e = e || window.event;
                    if (e.preventDefault) {
                        e.preventDefault();
                    }
                    if (e.stopPropagation) {
                        e.stopPropagation();
                    }
                    var img = document.querySelector('.elementChantiers img.img_dragging');
                    console.log('event: ', e);

                    // récupération de la position du drop
                    var position = $(canvasObject).offset();
                    var x = e.clientX - (position.left + positionX);
                    var y = e.clientY - (position.top + positionY);

                    // création d'une nouvelle image (celle qui sera placée sur le cadastre)
                    var newImage = new fabric.Image(img, {
                        width: img.width * scale,
                        height: img.height * scale,
                        left: x,
                        top: y,
                        lockScalingX: true,
                        lockScalingY: true,
                    });

                    // ajout de cette nouvelle image sur le canvas
                    canvas.add(newImage);

                    return false;
                }

                // Fonction DRAG END : une fois le drop effectué, l'image glissante disparaît
                function handleDragEnd(e) {
                    [].forEach.call(images, function(img) {
                        img.classList.remove('img_dragging');
                    });
                }

                // utilisation des fonctions de Drag & Drop pour l'élément de chantier sélectionné
                var images = document.querySelectorAll('.elementChantiers img');
                [].forEach.call(images, function(img) {
                    img.addEventListener('dragstart', handleDragStart, false);
                    img.addEventListener('dragend', handleDragEnd, false);
                });
                canvasContainer.addEventListener('dragEnter', handleDragEnter, false);
                canvasContainer.addEventListener('dragOver', handleDragOver, false);
                canvasContainer.addEventListener('dragLeave', handleDragLeave, false);
                canvasContainer.addEventListener('drop', handleDrop, false);
            });
        }
        // Utilisation de la fonction créée ci-dessus
        initCanvas();
    </script>

</body>

</html>